//+------------------------------------------------------------------+
//|                                          Momentum Candles v1.mq4 |
//|                                                              cja |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_width1 3
#property indicator_width2 3

extern double candle_pipvalue = 10;
extern double hilow_pipvalue  = 15;

double buffer1[];
double buffer2[];


double myPoint;
   double SetPoint() 
   { double mPoint; 
   if (Digits < 4) 
   mPoint = 0.01; 
   else
   mPoint = 0.0001; 
   return(mPoint); 
   } 
   
//---- parameters for alerting
input bool             alertsOn        = true;              // Alerts on true/false?
input bool             alertsOnCurrent = false;             // Alerts on open bar true/false?
input bool             alertsMessage   = true;              // Alerts message true/false?
input bool             alertsSound     = false;             // Alerts sound true/false?
input bool             alertsNotify    = false;             // Alerts notification true/false?
input bool             alertsEmail     = false;             // Alerts email true/false?
input string           soundFile       = "alert2.wav";      // Sound file
#define _mtfCall(_buff,_y) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,inpPeriod,High1,Low1,atrPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,_buff,_y)


//-----------------------------------
void init() {
   myPoint = SetPoint();
   IndicatorBuffers(2);
   
   SetIndexBuffer(0, buffer1);     
   SetIndexStyle(0, DRAW_HISTOGRAM);
   
   SetIndexBuffer(1, buffer2);     
   SetIndexStyle(1, DRAW_HISTOGRAM);
   
   IndicatorShortName("Momentum Candles");
   
         
   //return(0);
}
  
void deinit() { 
//return(0);
}
     
void start() {
    
   int counted_bars=IndicatorCounted();
  
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;
       
   int limit = Bars - counted_bars;     
      
   for(int i = limit; i >= 0; i--) {

      int shift = iBarShift(Symbol(), 0, Time[i], true);     
          
      buffer2[i] = 0;
      buffer1[i] = 0;      
          
      double close = iClose(Symbol(),0,shift);
      double open  = iOpen(Symbol(),0,shift);
      double high  = iHigh(Symbol(),0,shift);
      double low   = iLow(Symbol(),0,shift);
         
      if(open > close && (open-close)>=candle_pipvalue*myPoint && (high-low)>=hilow_pipvalue*myPoint) {
         
         buffer2[i] = close;      
         buffer1[i] = open;
         
            if (alertsOn){
               int whichBar = (alertsOnCurrent) ? 0 : 1;
               static datetime time1 = 0;
               static string   mess1 = "";
               doAlert(time1,mess1,whichBar,"Bear Candle"); 
              }  
         
      }
      
      if(open < close && (close-open)>=candle_pipvalue*myPoint && (high-low)>=hilow_pipvalue*myPoint) {
        
         buffer2[i] = close;
         buffer1[i] = open;
             
              if (alertsOn){
               int whichBar2 = (alertsOnCurrent) ? 0 : 1;
               static datetime time2 = 0;
               static string   mess2 = "";
               doAlert(time2,mess2,whichBar2,"Bull Candle"); 
              }  
   
         }      
      }
    } 
   //return(0);

// ===========================================================================================
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];
       
       //
       //
       //
       //
       //

       message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Momentum Candles "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(_Symbol+" Momentum Candles ",message);
          if (alertsSound)   PlaySound(soundFile);
      }
}
 